package it.mulders.mcs.search.vulnerability;

import java.util.Comparator;
import java.util.stream.Stream;

public record ComponentReportResponse(ComponentReport[] componentReports) {
    public record ComponentReport(
            String coordinates, String reference, ComponentReportVulnerability[] vulnerabilities) {
        public ComponentReportVulnerability[] vulnerabilitiesSortedByCvssScore() {
            return Stream.of(vulnerabilities)
                    .sorted(Comparator.comparingDouble(ComponentReportVulnerability::cvssScore)
                            .reversed())
                    .toArray(ComponentReportVulnerability[]::new);
        }

        public record ComponentReportVulnerability(String id, String title, Double cvssScore, String reference) {}
    }
}
