package it.mulders.mcs.search.vulnerability;

/**
 * Based on NVD Vulnerability Severity Ratings. Refer to NVD <a href="https://nvd.nist.gov/vuln-metrics/cvss">site</a>.
 */
public enum ComponentReportVulnerabilitySeverity {
    CRITICAL("Critical", 9.0),
    HIGH("High", 7.0),
    MEDIUM("Medium", 4.0),
    LOW("Low", 0.1),
    NONE("None", 0.0);

    ComponentReportVulnerabilitySeverity(String text, Double score) {
        this.text = text;
        this.score = score;
    }

    private final String text;
    private final Double score;

    public static String getText(Double score) {
        if (score.compareTo(CRITICAL.score) >= 0) {
            return CRITICAL.text;
        } else if (score.compareTo(HIGH.score) >= 0) {
            return HIGH.text;
        } else if (score.compareTo(MEDIUM.score) >= 0) {
            return MEDIUM.text;
        } else if (score.compareTo(LOW.score) >= 0) {
            return LOW.text;
        } else {
            return NONE.text;
        }
    }
}
